Image editing: edit an existing image per instructions
curl --request POST \
--url https://api.apiyi.com/v1beta/models/gemini-3.1-flash-lite-image:generateContent \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"contents": [
{
"parts": [
{
"text": "Composite the people from these two images into the same office scene, making funny faces"
},
{
"inlineData": {
"mimeType": "image/png",
"data": "<BASE64_DATA_IMG_1>"
}
},
{
"inlineData": {
"mimeType": "image/png",
"data": "<BASE64_DATA_IMG_2>"
}
}
]
}
],
"generationConfig": {
"responseModalities": [
"IMAGE"
],
"imageConfig": {
"aspectRatio": "16:9",
"imageSize": "1K"
}
}
}
'import requests
url = "https://api.apiyi.com/v1beta/models/gemini-3.1-flash-lite-image:generateContent"
payload = {
"contents": [{ "parts": [{ "text": "Composite the people from these two images into the same office scene, making funny faces" }, { "inlineData": {
"mimeType": "image/png",
"data": "<BASE64_DATA_IMG_1>"
} }, { "inlineData": {
"mimeType": "image/png",
"data": "<BASE64_DATA_IMG_2>"
} }] }],
"generationConfig": {
"responseModalities": ["IMAGE"],
"imageConfig": {
"aspectRatio": "16:9",
"imageSize": "1K"
}
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
contents: [
{
parts: [
{
text: 'Composite the people from these two images into the same office scene, making funny faces'
},
{inlineData: {mimeType: 'image/png', data: '<BASE64_DATA_IMG_1>'}},
{inlineData: {mimeType: 'image/png', data: '<BASE64_DATA_IMG_2>'}}
]
}
],
generationConfig: {
responseModalities: ['IMAGE'],
imageConfig: {aspectRatio: '16:9', imageSize: '1K'}
}
})
};
fetch('https://api.apiyi.com/v1beta/models/gemini-3.1-flash-lite-image:generateContent', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"candidates": [
{
"content": {
"parts": [
{
"inlineData": {
"mimeType": "image/png",
"data": "<string>"
}
}
]
},
"finishReason": "STOP"
}
],
"usageMetadata": {
"promptTokenCount": 10,
"candidatesTokenCount": 258
}
}Nano Banana Lite 이미지 생성
이미지 편집 API 레퍼런스
Nano Banana 2 Lite 이미지 편집 API 레퍼런스 및 대화형 플레이그라운드 — 이미지와 지시사항을 제공하여 편집된 결과를 생성합니다
POST
/
v1beta
/
models
/
gemini-3.1-flash-lite-image:generateContent
Image editing: edit an existing image per instructions
오른쪽의 대화형 플레이그라운드는 매개변수에 대한 드롭다운 선택을 지원합니다. Authorization 필드에 API 키를 입력하고(형식:
Bearer sk-xxx) 한 번의 클릭으로 테스트 요청을 보냅니다.범위: 이 페이지는 이미지 편집용입니다. 편집 지침과 함께 입력 이미지(base64로 인코딩됨)를 제공해야 합니다. 텍스트만으로 새 이미지를 생성하려면 텍스트-이미지 엔드포인트를 사용하십시오.
🖥️ 브라우저 플레이그라운드 제한(중요)이 엔드포인트는 응답에 base64로 인코딩된 이미지(
inlineData.data, 일반적으로 수 MB)를 반환합니다. 브라우저 렌더링 제한 때문에 오른쪽 플레이그라운드에 응답이 도착한 뒤 请求时发生错误: unable to complete request가 표시될 수 있습니다. — 요청은 실제로 성공했습니다; 브라우저가 이렇게 긴 base64 문자열을 렌더링할 수 없을 뿐입니다.권장 워크플로(초보자 친화적):- 아래의 Python / Node.js / cURL 샘플을 복사해 로컬에서 실행하십시오. 코드는 응답을 자동으로
base64.b64decodes하고 이미지를 파일에 씁니다. - 반드시 브라우저 내 플레이그라운드를 사용해야 한다면, **아주 작은 참조 이미지(50KB 미만)**를 사용해 응답 크기를 줄이십시오.
⚠️ 잘못된 예(각 부분에
parts 배열 구조(중요 — 다중 이미지 편집 시 읽으십시오)각 part는 text 또는 inlineData 중 하나여야 하며, 둘 다일 수는 없습니다. 이는 Google의 공식 gemini-3.1-flash-lite-image 계약과 일치합니다.올바른 예: 하나의 텍스트 부분(지침) + N개의 inlineData 부분(이미지당 하나씩):"contents": [{
"parts": [
{"text": "Combine the people from these two images into one office scene"},
{"inlineData": {"mimeType": "image/png", "data": "<BASE64_DATA_IMG_1>"}},
{"inlineData": {"mimeType": "image/png", "data": "<BASE64_DATA_IMG_2>"}}
]
}]
text와 inlineData가 모두 포함됨 — 정의되지 않은 동작을 일으킵니다):"contents": [{
"parts": [
{"inlineData": {...}, "text": "is this the prompt 1"},
{"inlineData": {...}, "text": "is this the prompt 2"}
]
}]
🖼️ 실행한 뒤에는
inlineData.data 필드에 대하여이 엔드포인트는 JSON 형식(multipart 파일 업로드가 아님)을 사용하므로, 플레이그라운드에서 로컬 파일을 직접 선택할 수 없습니다. 먼저 이미지를 Base64 문자열로 변환한 다음, data 입력란에 붙여넣어야 합니다.한 줄 명령: 변환 + 클립보드에 복사:# macOS
base64 -i your-image.jpg | tr -d '\n' | pbcopy
# Linux
base64 -w0 your-image.jpg | xclip -selection clipboard
# Windows PowerShell
[Convert]::ToBase64String([IO.File]::ReadAllBytes("your-image.jpg")) | Set-Clipboard
Cmd+V / Ctrl+V를 복사해 플레이그라운드의 data 필드에 붙여넣으면 됩니다. 또한 mimeType를 일치하는 image/jpeg 또는 image/png로 설정하는 것도 기억하십시오.권장 사항: 브라우저가 긴 base64 문자열 때문에 느려지는 것을 피하려면 테스트에는 작은 이미지(200KB 미만)를 사용하십시오. 이미지 편집 테스트를 자주 수행한다면, 대신 아래 코드 예제를 사용해 로컬에서 실행하십시오.코드 예제
Python
import requests
import base64
API_KEY = "sk-your-api-key"
# Read the image to edit
with open("input.jpg", "rb") as f:
image_b64 = base64.b64encode(f.read()).decode()
response = requests.post(
"https://api.apiyi.com/v1beta/models/gemini-3.1-flash-lite-image:generateContent",
headers={"Authorization": f"Bearer {API_KEY}", "Content-Type": "application/json"},
json={
"contents": [{
"parts": [
{"text": "Please blur the background to highlight the person in the foreground"},
{"inlineData": {"mimeType": "image/jpeg", "data": image_b64}}
]
}],
"generationConfig": {
"responseModalities": ["IMAGE"],
"imageConfig": {"aspectRatio": "16:9", "imageSize": "1K"}
}
},
timeout=300
).json()
img_data = response["candidates"][0]["content"]["parts"][0]["inlineData"]["data"]
with open("edited.png", 'wb') as f:
f.write(base64.b64decode(img_data))
print("Edited image saved to edited.png")
Node.js
import fs from "fs";
const API_KEY = "sk-your-api-key";
const imageB64 = fs.readFileSync("input.jpg").toString("base64");
const response = await fetch(
"https://api.apiyi.com/v1beta/models/gemini-3.1-flash-lite-image:generateContent",
{
method: "POST",
headers: {
"Authorization": `Bearer ${API_KEY}`,
"Content-Type": "application/json"
},
body: JSON.stringify({
contents: [{
parts: [
{ text: "Please blur the background to highlight the person in the foreground" },
{ inlineData: { mimeType: "image/jpeg", data: imageB64 } }
]
}],
generationConfig: {
responseModalities: ["IMAGE"],
imageConfig: { aspectRatio: "16:9", imageSize: "1K" }
}
})
}
);
const data = await response.json();
const imgBase64 = data.candidates[0].content.parts[0].inlineData.data;
fs.writeFileSync("edited.png", Buffer.from(imgBase64, "base64"));
cURL
# Note: convert image to base64 first
# IMAGE_B64=$(base64 -i input.jpg | tr -d '\n')
curl -X POST "https://api.apiyi.com/v1beta/models/gemini-3.1-flash-lite-image:generateContent" \
-H "Authorization: Bearer sk-your-api-key" \
-H "Content-Type: application/json" \
-d '{
"contents": [{
"parts": [
{"text": "Please blur the background to highlight the person in the foreground"},
{"inlineData": {"mimeType": "image/jpeg", "data": "'"$IMAGE_B64"'"}}
]
}],
"generationConfig": {
"responseModalities": ["IMAGE"],
"imageConfig": {"aspectRatio": "16:9", "imageSize": "1K"}
}
}'
다중 이미지 편집
여러 입력 이미지를 병합하거나 비교할 때는 하나의text 부분(지시문) 뒤에 여러 inlineData 부분(이미지당 하나씩)을 사용합니다.
Python (다중 이미지)
import requests
import base64
API_KEY = "sk-your-api-key"
def to_b64(path):
with open(path, "rb") as f:
return base64.b64encode(f.read()).decode()
# Prepare multiple images (2 here as an example)
images = ["person1.png", "person2.png"]
parts = [{"text": "Combine the people from these images into one office scene, making funny faces"}]
for path in images:
parts.append({"inlineData": {"mimeType": "image/png", "data": to_b64(path)}})
response = requests.post(
"https://api.apiyi.com/v1beta/models/gemini-3.1-flash-lite-image:generateContent",
headers={"Authorization": f"Bearer {API_KEY}", "Content-Type": "application/json"},
json={
"contents": [{"parts": parts}],
"generationConfig": {
"responseModalities": ["TEXT", "IMAGE"],
"imageConfig": {"aspectRatio": "5:4", "imageSize": "1K"}
}
},
timeout=300
).json()
img_data = response["candidates"][0]["content"]["parts"][0]["inlineData"]["data"]
with open("merged.png", "wb") as f:
f.write(base64.b64decode(img_data))
매개변수 빠른 참조
| 매개변수 | 유형 | 필수 | 설명 |
|---|---|---|---|
contents[].parts | array | Yes | 1 text part + N inlineData parts로 구성됩니다. 각 파트에는 text 또는 inlineData 중 하나만 포함되며 — 둘 다는 아닙니다 |
contents[].parts[].text | string | Yes | 편집 지시문(첫 번째 파트에만 넣습니다) |
contents[].parts[].inlineData.mimeType | string | Yes | image/jpeg 또는 image/png |
contents[].parts[].inlineData.data | string | Yes | Base64로 인코딩된 이미지(다중 이미지 편집에서는 이미지마다 inlineData 파트를 하나씩 반복합니다) |
generationConfig.responseModalities | array | Yes | 일반적으로 ["IMAGE"] |
generationConfig.imageConfig.aspectRatio | string | No | 14개의 비율, 기본값 1:1 |
generationConfig.imageConfig.imageSize | string | No | 1K만 해당(Lite는 1K 캔버스에 집중됩니다) |
다중 턴 대화형 편집
Nano Banana 2 Lite (gemini-3.1-flash-lite-image)는 대화형 다중 턴 편집을 지원합니다. 각 턴에서 생성된 이미지를 contents에 **role: "model" inlineData**로 다시 추가한 다음, 다음 사용자 지시를 전송합니다. 모델은 전체 대화 기록을 바탕으로 편집하고 변경 사항을 누적합니다(예: 먼저 소파의 색을 바꾸고, 그다음 액세서리를 추가하면 이전 변경 사항이 유지됩니다).
import requests, base64
API_KEY = "sk-your-api-key"
URL = "https://api.apiyi.com/v1beta/models/gemini-3.1-flash-lite-image:generateContent"
H = {"Authorization": f"Bearer {API_KEY}", "Content-Type": "application/json"}
CFG = {"responseModalities": ["IMAGE"], "imageConfig": {"aspectRatio": "1:1", "imageSize": "1K"}}
contents = [] # keep one running conversation history
def turn(instruction, save_to):
contents.append({"role": "user", "parts": [{"text": instruction}]})
data = requests.post(URL, headers=H,
json={"contents": contents, "generationConfig": CFG}, timeout=300).json()
part = next(p for p in data["candidates"][0]["content"]["parts"] if "inlineData" in p)
contents.append({"role": "model", "parts": [part]}) # key: backfill the output image into history
with open(save_to, "wb") as f:
f.write(base64.b64decode(part["inlineData"]["data"]))
return part
turn("Generate an orange cat sitting on a blue sofa, simple line-art style", "step1.png")
turn("Make the sofa red; keep the cat and composition unchanged", "step2.png") # edits the previous image
turn("Put a small yellow hat on the cat; keep everything else the same", "step3.png") # accumulates; red sofa kept
기존 이미지에서 다중 턴을 시작합니다: 기존 사진을 편집하기 위해 첫 번째 사용자 메시지에
inlineData(본인 이미지)와 지시사항을 넣고, 이후 각 턴마다 모델 출력을 contents에 계속 다시 채워 넣습니다.인증
API Key obtained from the APIYI console
본문
application/json
이 페이지가 도움이 되었나요?
⌘I